Loading...
Searching...
No Matches
cplanes_obj.c File Reference

Nviz library – Clip planes manipulation. More...

`#include <grass/nviz.h>`
Include dependency graph for cplanes_obj.c:

Go to the source code of this file.

## Functions

int | Nviz_new_cplane (nv_data *data, int id)
| Creates a clip plane object.
int | Nviz_on_cplane (nv_data *data, int id)
| Turn on (make current) the given clip plane.
int | Nviz_off_cplane (nv_data *data, int id)
| Turn off (make inactive) the given clip plane.
int | Nviz_draw_cplane (nv_data *data, int bound1, int bound2)
| Draw the clip plane.
int | Nviz_num_cplanes (nv_data *data)
| Return the number of clip planes objects currently allocated.
int | Nviz_get_current_cplane (nv_data *data)
| Get the current active cutplane.
int | Nviz_set_cplane_rotation (nv_data *data, int id, float dx, float dy, float dz)
| Set the rotation for the current clip plane.
int | Nviz_get_cplane_rotation (nv_data *data, int id, float *dx, float *dy, float *dz)
| Get the rotation values for the current clip plane.
int | Nviz_set_cplane_translation (nv_data *data, int id, float dx, float dy, float dz)
| Set the translation for the current clip plane.
int | Nviz_get_cplane_translation (nv_data *data, int id, float *dx, float *dy, float *dz)
| Get the translation values for the current clip plane.
int | Nviz_set_fence_color (nv_data *data, int type)
| Set appropriate fence color.
int | Nviz_set_cplane_here (nv_data *data, int cplane, float sx, float sy)

## Detailed Description

Nviz library – Clip planes manipulation.

Based on visualization/nviz/src/cutplanes_obj.c

(C) 2008, 2010 by the GRASS Development Team This program is free software under the GNU General Public License (>=v2). Read the file COPYING that comes with GRASS for details.

Author
  Updated/modified by Martin Landa <landa.martin gmail.com> (Google SoC 2008/2010)

Definition in file cplanes_obj.c.

## Function Documentation

## Nviz_draw_cplane()

int Nviz_draw_cplane | ( | nv_data * | data,
|  | int | bound1,
|  | int | bound2 )

Draw the clip plane.

Parameters

  data | nviz data
  bound1 |
  bound2 |

Definition at line 78 of file cplanes_obj.c.

## Nviz_get_cplane_rotation()

int Nviz_get_cplane_rotation | ( | nv_data * | data,
|  | int | id,
|  | float * | dx,
|  | float * | dy,
|  | float * | dz )

Get the rotation values for the current clip plane.

Parameters

  data | nviz data
  id | id of current clip plane
  dx,dy,dz | rotation parameters

Returns
  1

Definition at line 196 of file cplanes_obj.c.

References X, and Y.

## Nviz_get_cplane_translation()

int Nviz_get_cplane_translation | ( | nv_data * | data,
|  | int | id,
|  | float * | dx,
|  | float * | dy,
|  | float * | dz )

Get the translation values for the current clip plane.

Parameters

  data | nviz data
  id | id of current clip plane
  dx,dy,dz | translation parameters

Definition at line 236 of file cplanes_obj.c.

References X, and Y.

Referenced by Nviz_set_cplane_here().

## Nviz_get_current_cplane()

int Nviz_get_current_cplane | ( | nv_data * | data | ) |

Get the current active cutplane.

Parameters

  data | nviz data

Definition at line 157 of file cplanes_obj.c.

## Nviz_new_cplane()

int Nviz_new_cplane | ( | nv_data * | data,
|  | int | id )

Creates a clip plane object.

The number of clip planes is fixed (MAX_CPLANES) and we'll create them all ahead of time anyway we just let the user decide on the id for each.

Parameters

  data | nviz data
  id | cplane id

Definition at line 31 of file cplanes_obj.c.

References X, and Y.

Referenced by Nviz_init_data().

## Nviz_num_cplanes()

int Nviz_num_cplanes | ( | nv_data * | data | ) |

Return the number of clip planes objects currently allocated.

Parameters

  data | nviz data

Definition at line 147 of file cplanes_obj.c.

## Nviz_off_cplane()

int Nviz_off_cplane | ( | nv_data * | data,
|  | int | id )

Turn off (make inactive) the given clip plane.

Parameters

  data | nviz data
  id | cplane id

Definition at line 63 of file cplanes_obj.c.

References GS_unset_cplane().

Referenced by Nviz_init_data().

## Nviz_on_cplane()

int Nviz_on_cplane | ( | nv_data * | data,
|  | int | id )

Turn on (make current) the given clip plane.

Parameters

  data | nviz data
  id | cplane id

Definition at line 48 of file cplanes_obj.c.

References GS_set_cplane().

## Nviz_set_cplane_here()

int Nviz_set_cplane_here | ( | nv_data * | data,
|  | int | cplane,
|  | float | sx,
|  | float | sy )

Definition at line 258 of file cplanes_obj.c.

References GS_distance(), GS_get_region(), GS_get_selected_point_on_surface(), gs_get_surf(), GS_v3dir(), GS_v3mult(), gsd_get_los(), Nviz_get_cplane_translation(), Nviz_set_cplane_translation(), X, x, and Y.

## Nviz_set_cplane_rotation()

int Nviz_set_cplane_rotation | ( | nv_data * | data,
|  | int | id,
|  | float | dx,
|  | float | dy,
|  | float | dz )

Set the rotation for the current clip plane.

Parameters

  data | nviz data
  id | id of current clip plane
  dx,dy,dz | rotation parameters

Returns
  1

Definition at line 172 of file cplanes_obj.c.

References GS_set_cplane_rot(), X, and Y.

## Nviz_set_cplane_translation()

int Nviz_set_cplane_translation | ( | nv_data * | data,
|  | int | id,
|  | float | dx,
|  | float | dy,
|  | float | dz )

Set the translation for the current clip plane.

Parameters

  data | nviz data
  id | id of current clip plane
  dx,dy,dz | values for setting translation

Returns
  1

Definition at line 215 of file cplanes_obj.c.

References GS_set_cplane_trans(), X, and Y.

Referenced by Nviz_set_cplane_here().

## Nviz_set_fence_color()

int Nviz_set_fence_color | ( | nv_data * | data,
|  | int | type )

Set appropriate fence color.

Parameters

  type | type of fence (FC_ABOVE, FC_BELOW, FC_BLEND, FC_GREY, FC_OFF)

Definition at line 251 of file cplanes_obj.c.

References GS_set_fencecolor().